/*
 *	File:		utime.h
 *				1993-1995 metrowerks Inc. All rights reserved
 *	Author:		Berardino E. Baratta
 *
 *	Content:	Interface file to standard UNIX-style entry points ...
 *
 *	NB:			This file implements some UNIX low level support.  These functions
 *				are not guaranteed to be 100% conformant.
 */

#ifndef _UTIME
#define _UTIME

#ifndef _TIME
#include <time.h>
#endif

#pragma options align=mac68k

#if __CFM68K__ && __USING_IMPORTED_ANSI__
#pragma import on
#endif

/* struct for utime */
struct utimbuf {
	time_t actime;					/* access time (ignored on the Mac) */
	time_t modtime;					/* modification time */
};

/* struct for utimes */
struct timeval {
	int tv_sec;						/* seconds */
	int tv_usec;					/* microseconds (ignored on the Mac) */
};

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	Set the file time stamps.
 */
int utime(const char *path, const struct utimbuf *buf);

/*
 *	Set the file time stamps.
 */
int utimes(const char *path, struct timeval buf[2]);

#ifdef __cplusplus
}
#endif

#if __CFM68K__ && __USING_IMPORTED_ANSI__
#pragma import reset
#endif

#pragma options align=reset

#endif
